﻿'Import database controls -GR
Imports System.Data.OleDb

Class MainWindow
    'Declaration of the variables-GR
    Dim Suffix As String
    Dim Prefix As String
    Dim FirstName As String
    Dim MiddleName As String
    Dim LastName As String
    Dim Gender As String
    Dim Address As String
    Dim City As String
    Dim State As String
    Dim Zip As Integer
    Dim HomePhone As Integer
    Dim MobilePhone As Integer
    'Variables for the database connection
    Dim provider As String
    Dim dataFile As String
    Dim connString As String
    Dim myConnection As OleDbConnection = New OleDbConnection




    Private Sub AddBtn_Click(sender As Object, e As RoutedEventArgs) Handles AddBtn.Click
        'Warns the user that the Prefix was not selected for customer-GR
        Try
            Prefix = PrefixCB.Text
            If PrefixCB.SelectedIndex = -1 Then
                PrefixCB.Focus()
                MessageBox.Show("Warning! Please select a Customer's Prefix!")
                Return
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
            Return

        End Try


        'Calls method-GR
        NameValidate()



    End Sub

    Private Sub NameValidate()


        'Validates that the First Name text box are not empty or filled will numbers-GR
        Try
            FirstName = CStr(FirstTB.Text)
            If IsNumeric(FirstName) Or String.IsNullOrEmpty(FirstTB.Text) Then
                FirstTB.Clear()
                FirstTB.Focus()
                MessageBox.Show("Warning! Please enter a valid value for Customer's First Name!") 'Warns user-GR
                Return
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
            Return
        End Try

        'Validates that the Middle Name text box is not filled will numbers-GR
        Try
            MiddleName = CStr(MiddleTB.Text)
            If IsNumeric(MiddleName) Then
                MiddleTB.Clear()
                MiddleTB.Focus()
                MessageBox.Show("Warning! Please enter a non-numeric value for Customer's Middle Name!") 'Warns user-GR
                Return
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
            Return
        End Try

        'Validates that the Last Name text box are not empty or filled will numbers-GR
        Try
            LastName = CStr(LastTB.Text)
            If IsNumeric(LastName) Or String.IsNullOrEmpty(LastTB.Text) Then
                LastTB.Clear()
                LastTB.Focus()
                MessageBox.Show("Warning! Please enter a valid value for Customer's Last Name!") 'Warns user-GR
                Return
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
            Return
        End Try

        Suffix = SuffixCB.Text

        'Calls method-GR
        AddressValidate()
    End Sub

    Private Sub ExitBtn_Click(sender As Object, e As RoutedEventArgs) Handles ExitBtn.Click
        'Test the button to close the current form and return to main menu-GR
        Dim frmMenu As New Menu
        Me.Close()
        frmMenu.ShowDialog()
    End Sub

    Private Sub AddressValidate()

        'Validates that the Address text box to see if it contains incorrect input like just numeric or empty-GR
        Try
            Address = CStr(AddressTB.Text)
            If IsNumeric(Address) Or String.IsNullOrEmpty(AddressTB.Text) Then
                AddressTB.Clear()
                AddressTB.Focus()
                MessageBox.Show("Warning! Please enter a value for Customer's Address!") 'Warns user-GR
                Return
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
            Return
        End Try

        'Validates that the City text box to see if it contains incorrect input like just numeric or empty-GR
        Try
            City = CStr(CityTB.Text)
            If IsNumeric(City) Or String.IsNullOrEmpty(CityTB.Text) Then
                CityTB.Clear()
                CityTB.Focus()
                MessageBox.Show("Warning! Please enter a value for Customer's City!") 'Warns user-GR
                Return
            End If
        Catch ex As Exception
            CityTB.Clear()
            CityTB.Focus()
            MessageBox.Show(ex.Message)
            Return
        End Try

        'Validates that the State ComboBox has been selected or not and if not a warning is displayed-GR

        If StateCB.SelectedIndex = -1 Then
            StateCB.Focus()
            MessageBox.Show("Warning! Please select a Customer's State!") 'Warns user-GR
            Return
        Else
            State = StateCB.Text
        End If
        'Validates that the Zip text box to see if it contains incorrect input like just not numeric or empty-GR
        Try
            Zip = CInt(ZipTB.Text)
            If Not IsNumeric(Zip) Or IsNothing(ZipTB.Text) Then
                ZipTB.Clear()
                ZipTB.Focus()
                MessageBox.Show("Warning! Please enter a numeric value for Customer's Zip!") 'Warns user-GR
                Return
            End If
        Catch ex As Exception
            ZipTB.Clear()
            ZipTB.Focus()
            MessageBox.Show(ex.Message)
            Return
        End Try

        'Call method-GR
        PhoneValidate()
    End Sub

    Private Sub PhoneValidate()
        'Validates that the Home Phone text box to see if it contains incorrect input like just not numeric or empty-GR

        Try
            HomePhone = CInt(HPhoneTB.Text)
            If Not IsNumeric(HomePhone) Then
                HPhoneTB.Clear()
                HPhoneTB.Focus()
                MessageBox.Show("Warning! Please enter a numeric value for Customer's Home Phone!") 'Warns user-GR
                Return
            End If
        Catch ex As Exception
            HPhoneTB.Clear()
            HPhoneTB.Focus()
            MessageBox.Show(ex.Message)
            MessageBox.Show("Warning! Please enter a valid value for Customer's Mobile Phone!") 'Warns user-GR
            Return
        End Try
        'Validates that the Mobile Phone text box to see if it contains incorrect input like just not numeric or empty-GR
        Try
            MobilePhone = CInt(MPhoneTB.Text)
            If Not IsNumeric(MobilePhone) Then
                MPhoneTB.Clear()
                MPhoneTB.Focus()
                MessageBox.Show("Warning! Please enter a numeric value for Customer's Mobile Phone!") 'Warns user-GR
                Return
            End If
        Catch ex As Exception
            MPhoneTB.Clear()
            MPhoneTB.Focus()
            MessageBox.Show("Warning! Please enter a valid value for Customer's Mobile Phone!") 'Warns user-GR
            Return
        End Try
        'Call method-GR
        CustomerDisplay()

    End Sub

    Private Sub PrefixCB_SelectionChanged(sender As Object, e As SelectionChangedEventArgs) Handles PrefixCB.SelectionChanged
        'If the Prefix is changed to MR. then Gender is set to male anything else its set to Female
        If PrefixCB.SelectedIndex = 3 Then
            GenderCB.SelectedIndex = 1
            Gender = GenderCB.Text

        Else
            GenderCB.SelectedIndex = 0
            Gender = GenderCB.Text
        End If
    End Sub

    Private Sub CustomerDisplay()
        'Displays the customer information that was added to the datebase via a popup message.
        'This if statement checks the if the middle name and suffix is empty to display the 
        'message one way without middle name And suffix-GR
        If MiddleName = Nothing Then
            If Suffix = Nothing Then
                MessageBox.Show("New Customer Added" + vbNewLine +
                    FirstName + " " + LastName + vbNewLine +
                Address + vbNewLine +
                City + " " + State + " " + Zip.ToString() + vbNewLine +
                HomePhone.ToString() + vbNewLine +
                MobilePhone.ToString())
                'This elseif statement checks the if the middle name is empty but the suffix is not to
                'display the message one way without middle name but without suffix-GR
            ElseIf Suffix = SuffixCB.Text Then
                MessageBox.Show("New Customer Added" + vbNewLine +
                    FirstName + " " + LastName + " " + Suffix + vbNewLine +
                Address + vbNewLine +
                City + " " + State + " " + Zip.ToString() + vbNewLine +
                HomePhone.ToString() + vbNewLine +
                MobilePhone.ToString())
            End If
            'This Elseif statement checks the if the middle name is not empty but the suffix
            'is empty to display the message one way with middle name but without suffix-GR
        ElseIf MiddleName = MiddleTB.Text Then
            If Suffix = Nothing Then
                MessageBox.Show("New Customer Added" + vbNewLine +
                    FirstName + " " + MiddleName + " " + LastName + vbNewLine +
               Address + vbNewLine +
               City + " " + State + " " + Zip.ToString() + vbNewLine +
               HomePhone.ToString() + vbNewLine +
               MobilePhone.ToString())
                'This Elseif statement checks the if the middle name is not empty and the suffix
                'is not empty to display the message one way with middle name and suffix-GR
            ElseIf Suffix = SuffixCB.Text Then
                MessageBox.Show("New Customer Added" + vbNewLine +
                FirstName + " " + MiddleName + " " + LastName + " " + Suffix + vbNewLine +
                Address + vbNewLine +
                City + " " + State + " " + Zip.ToString() + vbNewLine +
                HomePhone.ToString() + vbNewLine +
                MobilePhone.ToString())
            End If
        End If
        'Calls method-GR
        database()

    End Sub
    Private Sub database()
        'Here provide the connection to the Rewards Database-GR
        provider = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source="
        dataFile = "Rewards_Customer_Database.accdb"
        connString = provider & dataFile
        myConnection.ConnectionString = connString
        myConnection.Open()
        'Declaration of the SQL that will be used to input the data into the database-GR
        Dim str As String
        'SQL string with the name of all the columns to be imported into the database-GR
        str = "Insert into Add_Customer(Prefix, First_Name, Middle_Name, Last_Name, Suffix, Gender, Address, City, State, Zip_Code, Home_Phone, Mobile_Phone) Values (?,?,?,?,?,?,?,?,?,?,?,?)"
        Dim cmd As OleDbCommand = New OleDbCommand(str, myConnection)
        'The values that are to be added corresponding to their counterpart in the table_GR
        cmd.Parameters.Add(New OleDbParameter("Prefix", CType(PrefixCB.Text, String)))
        cmd.Parameters.Add(New OleDbParameter("First_Name", CType(FirstTB.Text, String)))
        cmd.Parameters.Add(New OleDbParameter("Middle_Name", CType(MiddleTB.Text, String)))
        cmd.Parameters.Add(New OleDbParameter("Last_Name", CType(LastTB.Text, String)))
        cmd.Parameters.Add(New OleDbParameter("Suffix", CType(SuffixCB.Text, String)))
        cmd.Parameters.Add(New OleDbParameter("Gender", CType(GenderCB.Text, String)))
        cmd.Parameters.Add(New OleDbParameter("Address", CType(AddressTB.Text, String)))
        cmd.Parameters.Add(New OleDbParameter("City", CType(CityTB.Text, String)))
        cmd.Parameters.Add(New OleDbParameter("State", CType(StateCB.Text, String)))
        cmd.Parameters.Add(New OleDbParameter("Zip_Code", CType(ZipTB.Text, Integer)))
        cmd.Parameters.Add(New OleDbParameter("Home_Phone", CType(HPhoneTB.Text, Integer)))
        cmd.Parameters.Add(New OleDbParameter("Mobile_Phone", CType(MPhoneTB.Text, Integer)))
        Try
            'Runs the query-GR
            cmd.ExecuteNonQuery()
            cmd.Dispose()
            'Closed the database connection=GR
            myConnection.Close()
            'Call method
            Clearform()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub
    Private Sub Clearform()
        'Clears all the items to back to default to be ready for the next user input-GR
        SuffixCB.SelectedIndex = -1
        PrefixCB.SelectedIndex = -1
        StateCB.SelectedIndex = -1
        FirstTB.Clear()
        MiddleTB.Clear()
        LastTB.Clear()
        GenderCB.SelectedIndex = -1
        AddressTB.Clear()
        CityTB.Clear()
        ZipTB.Clear()
        HPhoneTB.Clear()
        MPhoneTB.Clear()
    End Sub
End Class